namespace CCI.WebSocketServerLIB.Models;
        // class declarations
         class MessageBase;
         class SerialMessage;
         class DigitalMessage;
         class AnalogMessage;
         class ReadyMessage;
         class SignedAnalogMessage;
         class RegistrationMessage;
         class ProxyOutputSignedAnalog;
         class ProxyOutputDigital;
         class ProxyOutputSerial;
         class ProxyInputSerial;
         class ProxyOutputAnalog;
         class ProxyInputDigital;
         class ProxyInputAnalog;
         class ProxyInputSignedAnalog;
         class MessageType;
         class ObjectMessage;
     class MessageBase 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class SerialMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Value[];
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class DigitalMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class AnalogMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Value;
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class ReadyMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class SignedAnalogMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_INTEGER Value;
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class RegistrationMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

     class ProxyOutputSignedAnalog 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , SIGNED_INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyOutputDigital 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyOutputSerial 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , STRING Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyInputSerial 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , STRING Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyOutputAnalog 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyInputDigital 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyInputAnalog 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

     class ProxyInputSignedAnalog 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION UpdateSignal ( INTEGER Signal , SIGNED_INTEGER Value );
        FUNCTION Clear ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        SIGNED_LONG_INTEGER Count;
    };

    static class MessageType // enum
    {
        static SIGNED_LONG_INTEGER Unknown;
        static SIGNED_LONG_INTEGER Analog;
        static SIGNED_LONG_INTEGER SignedAnalog;
        static SIGNED_LONG_INTEGER Serial;
        static SIGNED_LONG_INTEGER Digital;
        static SIGNED_LONG_INTEGER Object;
        static SIGNED_LONG_INTEGER Registration;
        static SIGNED_LONG_INTEGER Ready;
    };

     class ObjectMessage 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        MessageType Type;
        STRING Id[];
        LONG_INTEGER Index;
    };

namespace CCI.WebSocketServerLIB.EventArguments;
        // class declarations
         class AnalogEventArgs;
         class SignedAnalogEventArgs;
         class BooleanEventArgs;
         class StringEventArgs;
         class DigitalEventArgs;
     class AnalogEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Index;
        INTEGER Payload;
    };

     class SignedAnalogEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Index;
        SIGNED_INTEGER Payload;
    };

     class BooleanEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Index;
    };

     class StringEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Index;
        STRING Payload[];
    };

     class DigitalEventArgs 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        INTEGER Index;
        INTEGER Payload;
    };

namespace CCI.WebSocketServerLIB.Senders;
        // class declarations
         class WebSocketSender;

namespace CCI.WebSocketServerLIB.Components;
        // class declarations
         class ComponentTypes;
         class AnalogComponent;
         class SignedAnalogComponent;
         class DigitalComponent;
         class SerialComponent;
    static class ComponentTypes // enum
    {
        static SIGNED_LONG_INTEGER Unknown;
        static SIGNED_LONG_INTEGER Digital;
        static SIGNED_LONG_INTEGER Analog;
        static SIGNED_LONG_INTEGER SignedAnalog;
        static SIGNED_LONG_INTEGER Serial;
    };

     class AnalogComponent 
    {
        // class delegates

        // class events
        EventHandler OnSignalChange ( AnalogComponent sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetFeedback ( INTEGER Index , INTEGER State );
        FUNCTION ProcessStateChange ( INTEGER Index , INTEGER State );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
        ComponentTypes Type;
    };

     class SignedAnalogComponent 
    {
        // class delegates

        // class events
        EventHandler OnSignalChange ( SignedAnalogComponent sender, SignedAnalogEventArgs args );

        // class functions
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetFeedback ( INTEGER Index , SIGNED_INTEGER State );
        FUNCTION ProcessStateChange ( INTEGER Index , SIGNED_INTEGER State );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
        ComponentTypes Type;
    };

     class DigitalComponent 
    {
        // class delegates

        // class events
        EventHandler OnSignalChange ( DigitalComponent sender, DigitalEventArgs args );

        // class functions
        FUNCTION SetFeedback ( INTEGER Index , INTEGER State );
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
        ComponentTypes Type;
    };

     class SerialComponent 
    {
        // class delegates

        // class events
        EventHandler OnSignalChange ( SerialComponent sender, StringEventArgs args );

        // class functions
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetFeedback ( INTEGER Index , STRING State );
        FUNCTION ProcessStateChange ( INTEGER Index , STRING State );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
        ComponentTypes Type;
    };

namespace CCI.WebSocketServerLIB.Parsers;
        // class declarations
         class WebSocketParser;

namespace CCI.WebSocketServerLIB.Utlities;
        // class declarations
         class ProxyUtil;
         class JoinUtil;
         class WebsocketUtil;
     class ProxyUtil 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class JoinUtil 
    {
        // class delegates

        // class events

        // class functions
        static LONG_INTEGER_FUNCTION BuildJoin ( INTEGER ObjectId , INTEGER Index );
        static INTEGER_FUNCTION GetObjectId ( LONG_INTEGER Join );
        static INTEGER_FUNCTION GetIndex ( LONG_INTEGER Join );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class WebsocketUtil 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

namespace CCI.WebSocketServerLIB.Registration;
        // class declarations
         class Registrar;
     class Registrar 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

namespace CCI.WebSocketServerLIB.Servers;
        // class declarations
         class Server;
         class WebSocketServer;
         class SecureWebSocketServer;

namespace CCI.WebSocketServerLIB.SmartComponents;
        // class declarations
         class SmartComponent;
         class KeypadComponent;
         class DialpadComponent;
     class SmartComponent 
    {
        // class delegates

        // class events
        EventHandler OnDigitalSignalChange ( SmartComponent sender, DigitalEventArgs args );
        EventHandler OnAnalogSignalChange ( SmartComponent sender, AnalogEventArgs args );
        EventHandler OnSignedAnalogSignalChange ( SmartComponent sender, SignedAnalogEventArgs args );
        EventHandler OnSerialSignalChange ( SmartComponent sender, StringEventArgs args );

        // class functions
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetDigitalFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetAnalogFeedback ( INTEGER Index , INTEGER Value );
        FUNCTION SetSignedAnalogFeedback ( INTEGER Index , SIGNED_INTEGER Value );
        FUNCTION SetSerialFeedback ( INTEGER Index , STRING Value );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
    };

     class KeypadComponent 
    {
        // class delegates

        // class events
        EventHandler OnDigitSignalChange ( KeypadComponent sender, DigitalEventArgs args );
        EventHandler OnDigitalSignalChange ( KeypadComponent sender, DigitalEventArgs args );
        EventHandler OnAnalogSignalChange ( KeypadComponent sender, AnalogEventArgs args );
        EventHandler OnSignedAnalogSignalChange ( KeypadComponent sender, SignedAnalogEventArgs args );
        EventHandler OnSerialSignalChange ( KeypadComponent sender, StringEventArgs args );

        // class functions
        FUNCTION SetDigitTextMain ( INTEGER Index , STRING Text );
        FUNCTION SetDigitTextAlpha ( INTEGER Index , STRING Text );
        FUNCTION SetDigitFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetDisableFeedback ( INTEGER State );
        FUNCTION SetHideFeedback ( INTEGER State );
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetDigitalFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetAnalogFeedback ( INTEGER Index , INTEGER Value );
        FUNCTION SetSignedAnalogFeedback ( INTEGER Index , SIGNED_INTEGER Value );
        FUNCTION SetSerialFeedback ( INTEGER Index , STRING Value );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        static INTEGER MAX_DIGITS;
        static INTEGER DISABLE_JOIN;
        static INTEGER HIDE_JOIN;
        static INTEGER DIGIT_BASE;
        static INTEGER DIGIT_TEXT_MAIN_BASE;
        static INTEGER DIGIT_TEXT_ALPHA_BASE;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
    };

     class DialpadComponent 
    {
        // class delegates

        // class events
        EventHandler OnDialstringChange ( DialpadComponent sender, StringEventArgs args );
        EventHandler OnOtherButtonSignalChange ( DialpadComponent sender, DigitalEventArgs args );
        EventHandler OnDigitSignalChange ( DialpadComponent sender, DigitalEventArgs args );
        EventHandler OnDigitalSignalChange ( DialpadComponent sender, DigitalEventArgs args );
        EventHandler OnAnalogSignalChange ( DialpadComponent sender, AnalogEventArgs args );
        EventHandler OnSignedAnalogSignalChange ( DialpadComponent sender, SignedAnalogEventArgs args );
        EventHandler OnSerialSignalChange ( DialpadComponent sender, StringEventArgs args );

        // class functions
        FUNCTION SetDigitTextMain ( INTEGER Index , STRING Text );
        FUNCTION SetDigitFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetDialstring ( STRING Text );
        FUNCTION SetDialstringFeedback ( STRING Text );
        FUNCTION SetOtherButtonFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetDialstringUseDTMFFeedback ( INTEGER State );
        FUNCTION SetDigitTextAlpha ( INTEGER Index , STRING Text );
        FUNCTION SetDisableFeedback ( INTEGER State );
        FUNCTION SetHideFeedback ( INTEGER State );
        FUNCTION Configure ( STRING PanelId , INTEGER ObjectId , INTEGER Remote );
        FUNCTION SetDigitalFeedback ( INTEGER Index , INTEGER State );
        FUNCTION SetAnalogFeedback ( INTEGER Index , INTEGER Value );
        FUNCTION SetSignedAnalogFeedback ( INTEGER Index , SIGNED_INTEGER Value );
        FUNCTION SetSerialFeedback ( INTEGER Index , STRING Value );
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        static INTEGER MAX_OTHER_BUTTONS;
        static INTEGER DIALSTRING_JOIN;
        static INTEGER DIALSTRING_DTMF_JOIN;
        static INTEGER OTHER_BUTTONS_BASE;
        static INTEGER CLEAR_JOIN;
        static INTEGER BACK_JOIN;
        static INTEGER MAX_DIGITS;
        static INTEGER DISABLE_JOIN;
        static INTEGER HIDE_JOIN;
        static INTEGER DIGIT_BASE;
        static INTEGER DIGIT_TEXT_MAIN_BASE;
        static INTEGER DIGIT_TEXT_ALPHA_BASE;

        // class properties
        STRING PanelId[];
        INTEGER ObjectId;
    };

namespace CCI.WebSocketServerLIB;
        // class declarations
         class WSServer;
     class WSServer 
    {
        // class delegates

        // class events
        EventHandler OnServerIsRunningChange ( WSServer sender, DigitalEventArgs args );
        EventHandler OnClientCountChange ( WSServer sender, AnalogEventArgs args );

        // class functions
        FUNCTION Configure ( INTEGER UseSsl , INTEGER Port , INTEGER ConnectionCount );
        FUNCTION Start ();
        FUNCTION Stop ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

namespace CCI.WebSocketServerLIB.JsonConverters;
        // class declarations
         class WebSocketResponseConverter;
     class WebSocketResponseConverter 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

namespace CCI.WebSocketServerLIB.Extentions;
        // class declarations

